
Core - Task # 54085

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Story # 55078 (Closed): Optimize PHP code performance in TYPO3 methods

Status: Resolved Priority: Should have
Author: Markus Klein Category: Performance
Created: 2013-11-29 Assigned To:
Updated: 2014-05-05 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: easy
Sprint Focus:
Subject: Replace all strcmp() calls with ===
Description

When testing for the identity of strings using the strcmp() function has worse performance than the === operator. (3-5x)

Replace all ~300 calls to strcmp() with the operator.

Attention: This is replacement only works when the return value of strcmp() is checked for being a boolean value, otherwise a string
ordering is performed and the call MUST NOT be replaced!

The  operator is also slower than the = operator, so use the latter one if possible.

Related issues:
related to Core - Task # 54265: Use (int) instead of intval() or (integer) Resolved 2013-12-07
related to Core - Task # 54517: Replace substr() and strpos() with GeneralUti... Accepted 2013-12-19
related to Core - Bug # 56248:  You can not add new records (TCA) in the edit... Resolved 2014-02-24
related to Core - Bug # 58525: First usergroup from BE-user no longer applied... Closed 2014-05-05
related to Core - Task # 56393: creation on new pages have broken permissions... Resolved 2014-02-27

Associated revisions
Revision 0a761995 - 2014-01-09 15:09 - Jo Hasenau

[TASK] Replace all strcmp() calls with ===

This patch replaces about 300 places using strcmp()
in the whole core. There are different contexts for strcmp()
within this set, i.e. checking for strings being '0',
'', not '' and the like.

strcmp() has to stay when it comes to real sorting of strings,
which is a rather rare case, otherwise it can be replaced with
faster alternatives.

The following 'rules' were used for the replacement:

    -  Use a type cast if you can't be sure about the incoming values.
  We do not need type casts if the types are implicitly defined
  before by another function. i.e. intval(), trim(), substr()

    -  Use int-cast whenever the values to be compared are numbers only.
    -  Use string-cast for any other combination. i.e
  (string)$len === '0' when $len can be NULL, which is different
  to (int)$len === 0

Resolves: #54085
Releases: 6.2
Change-Id: I88fb294ae20d8c23ff58d8296fbb37925d5213c8
Reviewed-on: https://review.typo3.org/25843
Reviewed-by: Markus Klein
Tested-by: Markus Klein

Revision 630b877b - 2014-02-28 14:19 - André Haehnel

[BUGFIX] Adding new records in edit mode broken

It was not possible anymore to use the "add new record" button
in TCA select fields on records with pid > 0.

This patch makes it work again; the redirect to the original page
gets prevented when a pid is set. This was handled the same way
in 4.6 and 6.1.

Change-Id: Iec058818405385efdacaebf5080f339371356810
Resolves: #56248
Related: #54085
Releases: 6.2
Reviewed-on: https://review.typo3.org/27935
Reviewed-by: Helmut Hummel
Tested-by: Helmut Hummel

History
#1 - 2013-11-29 17:02 - Jo Hasenau

I will take care of it the next days - thanks for opening the issue :-)

#2 - 2013-11-29 17:09 - Markus Klein

@Jo: Maybe http://forge.typo3.org/issues/54091 is relevant too.

#3 - 2013-12-01 14:40 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#4 - 2013-12-01 15:09 - Gerrit Code Review
Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#5 - 2013-12-01 15:37 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#6 - 2013-12-01 15:38 - Jo Hasenau

Attention: This is replacement only works when the return value of strcmp() is checked for being zero, otherwise a string ordering is performed
and the call MUST NOT be replaced!

Shouldn't it be:  "is checked for being zero or not being zero"

Actually strcmp is meant to be used for sorting of strings, since it can return positive or negative values for cases when string A is "larger" or "smaller"
than string B. It will return 0 when string "A" and string "B" are equal.

So any case that is just checking for the result of strcmp being TRUE or FALSE could IMHO be safely replaced.
In some cases we might have to add isset() before the === operator since NULL could be !== '' but still might have to be considered ''.

Anyway even

isset($foo) && $foo !== ''

will perform better, since it will just skip the operator in cases when $foo is NULL and it will no create any copies, so the memory footprint will be
significantly smaller.

#7 - 2013-12-01 16:06 - Markus Klein

I updated the description to be more precise about the boolean usage.

And it would be great to see some memory footprint in the end. The question surely is not if we have a reduction, but rather how much it finally really
is. ;-)

#8 - 2013-12-01 16:16 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#9 - 2013-12-01 17:15 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843
#10 - 2013-12-01 19:31 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#11 - 2013-12-01 20:09 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#12 - 2013-12-02 11:27 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#13 - 2013-12-02 14:17 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#14 - 2013-12-02 14:45 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#15 - 2013-12-04 22:42 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#16 - 2013-12-05 00:28 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#17 - 2013-12-05 10:21 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#18 - 2013-12-07 13:06 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843
#19 - 2013-12-07 14:09 - Gerrit Code Review

Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#20 - 2013-12-07 15:16 - Gerrit Code Review

Patch set 16 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#21 - 2013-12-07 17:25 - Gerrit Code Review

Patch set 17 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#22 - 2013-12-07 17:27 - Gerrit Code Review

Patch set 18 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#23 - 2013-12-08 00:38 - Gerrit Code Review

Patch set 19 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#24 - 2013-12-08 12:16 - Gerrit Code Review

Patch set 20 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#25 - 2013-12-09 15:54 - Gerrit Code Review

Patch set 21 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#26 - 2013-12-10 20:43 - Gerrit Code Review

Patch set 22 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#27 - 2013-12-19 14:05 - Gerrit Code Review

Patch set 23 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843
#28 - 2013-12-19 16:01 - Gerrit Code Review

Patch set 24 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#29 - 2013-12-19 16:14 - Gerrit Code Review

Patch set 25 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#30 - 2013-12-19 16:46 - Gerrit Code Review

Patch set 26 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#31 - 2013-12-19 17:34 - Gerrit Code Review

Patch set 27 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#32 - 2013-12-19 17:35 - Gerrit Code Review

Patch set 28 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#33 - 2014-01-09 15:08 - Gerrit Code Review

Patch set 29 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25843

#34 - 2014-01-09 15:30 - Jo Hasenau
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:0a761995a14e870c7a2f21547acf073c9293d856.

#35 - 2014-01-28 09:54 - Ernesto Baschny
- Target version changed from next-patchlevel to 6.2.0
- Parent task changed from #52949 to #55078

#36 - 2014-05-05 18:14 - Markus Klein

Regression in #56393
